VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Cars"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"34F5AD8B0030"
Option Explicit

' $Version: $
' $Auteur: Davids $
' $Date: 15/4/98 5:37p $

'------------------------------------------------------------------------
' Objet:      Donne des informations sur les autos
' Classes utilises: none
' References:   ADO
'------------------------------------------------------------------------


Public Function GetAll(Optional ConnectionString As Variant) As ADODB.Recordset
Attribute GetAll.VB_Description = "Returns a recordset of all available cars"
'
' Objet:      Cre un recordset de toutes les autos
' Arguments:    ConnectionString    Optionnel
' Retours:      Recordset
' Auteur:       DaviD Sussman
' Date:         19 Fb 1998

    Dim recCars             As New ADODB.Recordset  ' recordset des autos
    Dim varConn             As Variant              ' chane connexion

    ' tablit la connexion
    If IsMissing(ConnectionString) Then
        varConn = RegistryRestore("Showroom", "Not Set")
    Else
        varConn = ConnectionString
    End If

    ' lecture autos
    recCars.Open "usp_cars", varConn, adOpenStatic, adLockReadOnly, adCmdStoredProc
    Set GetAll = recCars

    recCars.Close
    Set recCars = Nothing

End Function

Public Function ColorsByCar(CarID As Long, Optional ConnectionString As Variant) As ADODB.Recordset
Attribute ColorsByCar.VB_Description = "Returns a recordset of all colors for the selected car"
'
' But:      cre un recordset des couleurs d'un modle donn
' Arguments:    CarID               No auto pour obtenir les couleurs
'               ConnectionString    Optionnel
' Retours:      Recordset des couleurs
' Auteur:       David Sussman
' Date:         19 Fb 1998
    Dim cmdColors           As New ADODB.Command        ' commande SQL
    Dim varConn             As Variant                  ' chane connexion

    ' tablit connexion
    If IsMissing(ConnectionString) Then
        varConn = RegistryRestore("Showroom", "Not Set")
    Else
        varConn = ConnectionString
    End If

    ' lecture couleurs
    With cmdColors
        .ActiveConnection = varConn
        .CommandType = adCmdStoredProc
        .CommandText = "usp_ColorsByCar"

        .Parameters.Append .CreateParameter("CarID", adInteger, adParamInput, 8, CarID)

        Set ColorsByCar = .Execute
    End With

    Set cmdColors = Nothing

End Function
